// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`DescribeConfigRuleEvaluationStatus`](crate::operation::describe_config_rule_evaluation_status::builders::DescribeConfigRuleEvaluationStatusFluentBuilder) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::operation::describe_config_rule_evaluation_status::builders::DescribeConfigRuleEvaluationStatusFluentBuilder::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_names(impl Into<String>)`](crate::operation::describe_config_rule_evaluation_status::builders::DescribeConfigRuleEvaluationStatusFluentBuilder::config_rule_names) / [`set_config_rule_names(Option<Vec::<String>>)`](crate::operation::describe_config_rule_evaluation_status::builders::DescribeConfigRuleEvaluationStatusFluentBuilder::set_config_rule_names):<br>required: **false**<br><p>The name of the Config managed rules for which you want status information. If you do not specify any names, Config returns status information for all Config managed rules that you use.</p><br>
    ///   - [`next_token(impl Into<String>)`](crate::operation::describe_config_rule_evaluation_status::builders::DescribeConfigRuleEvaluationStatusFluentBuilder::next_token) / [`set_next_token(Option<String>)`](crate::operation::describe_config_rule_evaluation_status::builders::DescribeConfigRuleEvaluationStatusFluentBuilder::set_next_token):<br>required: **false**<br><p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p><br>
    ///   - [`limit(i32)`](crate::operation::describe_config_rule_evaluation_status::builders::DescribeConfigRuleEvaluationStatusFluentBuilder::limit) / [`set_limit(Option<i32>)`](crate::operation::describe_config_rule_evaluation_status::builders::DescribeConfigRuleEvaluationStatusFluentBuilder::set_limit):<br>required: **false**<br><p>The number of rule evaluation results that you want returned.</p> <p>This parameter is required if the rule limit for your account is more than the default of 150 rules.</p> <p>For information about requesting a rule limit increase, see <a href="http://docs.aws.amazon.com/general/latest/gr/aws_service_limits.html#limits_config">Config Limits</a> in the <i>Amazon Web Services General Reference Guide</i>.</p><br>
    /// - On success, responds with [`DescribeConfigRuleEvaluationStatusOutput`](crate::operation::describe_config_rule_evaluation_status::DescribeConfigRuleEvaluationStatusOutput) with field(s):
    ///   - [`config_rules_evaluation_status(Option<Vec::<ConfigRuleEvaluationStatus>>)`](crate::operation::describe_config_rule_evaluation_status::DescribeConfigRuleEvaluationStatusOutput::config_rules_evaluation_status): <p>Status information about your Config managed rules.</p>
    ///   - [`next_token(Option<String>)`](crate::operation::describe_config_rule_evaluation_status::DescribeConfigRuleEvaluationStatusOutput::next_token): <p>The string that you use in a subsequent request to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeConfigRuleEvaluationStatusError>`](crate::operation::describe_config_rule_evaluation_status::DescribeConfigRuleEvaluationStatusError)
    pub fn describe_config_rule_evaluation_status(
        &self,
    ) -> crate::operation::describe_config_rule_evaluation_status::builders::DescribeConfigRuleEvaluationStatusFluentBuilder {
        crate::operation::describe_config_rule_evaluation_status::builders::DescribeConfigRuleEvaluationStatusFluentBuilder::new(self.handle.clone())
    }
}
