// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`GetAggregateComplianceDetailsByConfigRule`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::set_configuration_aggregator_name):<br>required: **true**<br><p>The name of the configuration aggregator.</p><br>
    ///   - [`config_rule_name(impl Into<String>)`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::config_rule_name) / [`set_config_rule_name(Option<String>)`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::set_config_rule_name):<br>required: **true**<br><p>The name of the Config rule for which you want compliance information.</p><br>
    ///   - [`account_id(impl Into<String>)`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::account_id) / [`set_account_id(Option<String>)`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::set_account_id):<br>required: **true**<br><p>The 12-digit account ID of the source account.</p><br>
    ///   - [`aws_region(impl Into<String>)`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::aws_region) / [`set_aws_region(Option<String>)`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::set_aws_region):<br>required: **true**<br><p>The source region from where the data is aggregated.</p><br>
    ///   - [`compliance_type(ComplianceType)`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::compliance_type) / [`set_compliance_type(Option<ComplianceType>)`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::set_compliance_type):<br>required: **false**<br><p>The resource compliance status.</p><note>  <p>For the <code>GetAggregateComplianceDetailsByConfigRuleRequest</code> data type, Config supports only the <code>COMPLIANT</code> and <code>NON_COMPLIANT</code>. Config does not support the <code>NOT_APPLICABLE</code> and <code>INSUFFICIENT_DATA</code> values.</p> </note><br>
    ///   - [`limit(i32)`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::limit) / [`set_limit(Option<i32>)`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::set_limit):<br>required: **false**<br><p>The maximum number of evaluation results returned on each page. The default is 50. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p><br>
    ///   - [`next_token(impl Into<String>)`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::next_token) / [`set_next_token(Option<String>)`](crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::set_next_token):<br>required: **false**<br><p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p><br>
    /// - On success, responds with [`GetAggregateComplianceDetailsByConfigRuleOutput`](crate::operation::get_aggregate_compliance_details_by_config_rule::GetAggregateComplianceDetailsByConfigRuleOutput) with field(s):
    ///   - [`aggregate_evaluation_results(Option<Vec::<AggregateEvaluationResult>>)`](crate::operation::get_aggregate_compliance_details_by_config_rule::GetAggregateComplianceDetailsByConfigRuleOutput::aggregate_evaluation_results): <p>Returns an AggregateEvaluationResults object.</p>
    ///   - [`next_token(Option<String>)`](crate::operation::get_aggregate_compliance_details_by_config_rule::GetAggregateComplianceDetailsByConfigRuleOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<GetAggregateComplianceDetailsByConfigRuleError>`](crate::operation::get_aggregate_compliance_details_by_config_rule::GetAggregateComplianceDetailsByConfigRuleError)
    pub fn get_aggregate_compliance_details_by_config_rule(
        &self,
    ) -> crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder {
        crate::operation::get_aggregate_compliance_details_by_config_rule::builders::GetAggregateComplianceDetailsByConfigRuleFluentBuilder::new(
            self.handle.clone(),
        )
    }
}
