// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`GetAggregateDiscoveredResourceCounts`](crate::operation::get_aggregate_discovered_resource_counts::builders::GetAggregateDiscoveredResourceCountsFluentBuilder) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::operation::get_aggregate_discovered_resource_counts::builders::GetAggregateDiscoveredResourceCountsFluentBuilder::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::operation::get_aggregate_discovered_resource_counts::builders::GetAggregateDiscoveredResourceCountsFluentBuilder::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::operation::get_aggregate_discovered_resource_counts::builders::GetAggregateDiscoveredResourceCountsFluentBuilder::set_configuration_aggregator_name):<br>required: **true**<br><p>The name of the configuration aggregator.</p><br>
    ///   - [`filters(ResourceCountFilters)`](crate::operation::get_aggregate_discovered_resource_counts::builders::GetAggregateDiscoveredResourceCountsFluentBuilder::filters) / [`set_filters(Option<ResourceCountFilters>)`](crate::operation::get_aggregate_discovered_resource_counts::builders::GetAggregateDiscoveredResourceCountsFluentBuilder::set_filters):<br>required: **false**<br><p>Filters the results based on the <code>ResourceCountFilters</code> object.</p><br>
    ///   - [`group_by_key(ResourceCountGroupKey)`](crate::operation::get_aggregate_discovered_resource_counts::builders::GetAggregateDiscoveredResourceCountsFluentBuilder::group_by_key) / [`set_group_by_key(Option<ResourceCountGroupKey>)`](crate::operation::get_aggregate_discovered_resource_counts::builders::GetAggregateDiscoveredResourceCountsFluentBuilder::set_group_by_key):<br>required: **false**<br><p>The key to group the resource counts.</p><br>
    ///   - [`limit(i32)`](crate::operation::get_aggregate_discovered_resource_counts::builders::GetAggregateDiscoveredResourceCountsFluentBuilder::limit) / [`set_limit(Option<i32>)`](crate::operation::get_aggregate_discovered_resource_counts::builders::GetAggregateDiscoveredResourceCountsFluentBuilder::set_limit):<br>required: **false**<br><p>The maximum number of <code>GroupedResourceCount</code> objects returned on each page. The default is 1000. You cannot specify a number greater than 1000. If you specify 0, Config uses the default.</p><br>
    ///   - [`next_token(impl Into<String>)`](crate::operation::get_aggregate_discovered_resource_counts::builders::GetAggregateDiscoveredResourceCountsFluentBuilder::next_token) / [`set_next_token(Option<String>)`](crate::operation::get_aggregate_discovered_resource_counts::builders::GetAggregateDiscoveredResourceCountsFluentBuilder::set_next_token):<br>required: **false**<br><p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p><br>
    /// - On success, responds with [`GetAggregateDiscoveredResourceCountsOutput`](crate::operation::get_aggregate_discovered_resource_counts::GetAggregateDiscoveredResourceCountsOutput) with field(s):
    ///   - [`total_discovered_resources(i64)`](crate::operation::get_aggregate_discovered_resource_counts::GetAggregateDiscoveredResourceCountsOutput::total_discovered_resources): <p>The total number of resources that are present in an aggregator with the filters that you provide.</p>
    ///   - [`group_by_key(Option<String>)`](crate::operation::get_aggregate_discovered_resource_counts::GetAggregateDiscoveredResourceCountsOutput::group_by_key): <p>The key passed into the request object. If <code>GroupByKey</code> is not provided, the result will be empty.</p>
    ///   - [`grouped_resource_counts(Option<Vec::<GroupedResourceCount>>)`](crate::operation::get_aggregate_discovered_resource_counts::GetAggregateDiscoveredResourceCountsOutput::grouped_resource_counts): <p>Returns a list of GroupedResourceCount objects.</p>
    ///   - [`next_token(Option<String>)`](crate::operation::get_aggregate_discovered_resource_counts::GetAggregateDiscoveredResourceCountsOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<GetAggregateDiscoveredResourceCountsError>`](crate::operation::get_aggregate_discovered_resource_counts::GetAggregateDiscoveredResourceCountsError)
    pub fn get_aggregate_discovered_resource_counts(
        &self,
    ) -> crate::operation::get_aggregate_discovered_resource_counts::builders::GetAggregateDiscoveredResourceCountsFluentBuilder {
        crate::operation::get_aggregate_discovered_resource_counts::builders::GetAggregateDiscoveredResourceCountsFluentBuilder::new(
            self.handle.clone(),
        )
    }
}
