// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`GetComplianceDetailsByConfigRule`](crate::operation::get_compliance_details_by_config_rule::builders::GetComplianceDetailsByConfigRuleFluentBuilder) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::operation::get_compliance_details_by_config_rule::builders::GetComplianceDetailsByConfigRuleFluentBuilder::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_name(impl Into<String>)`](crate::operation::get_compliance_details_by_config_rule::builders::GetComplianceDetailsByConfigRuleFluentBuilder::config_rule_name) / [`set_config_rule_name(Option<String>)`](crate::operation::get_compliance_details_by_config_rule::builders::GetComplianceDetailsByConfigRuleFluentBuilder::set_config_rule_name):<br>required: **true**<br><p>The name of the Config rule for which you want compliance information.</p><br>
    ///   - [`compliance_types(ComplianceType)`](crate::operation::get_compliance_details_by_config_rule::builders::GetComplianceDetailsByConfigRuleFluentBuilder::compliance_types) / [`set_compliance_types(Option<Vec::<ComplianceType>>)`](crate::operation::get_compliance_details_by_config_rule::builders::GetComplianceDetailsByConfigRuleFluentBuilder::set_compliance_types):<br>required: **false**<br><p>Filters the results by compliance.</p> <p><code>INSUFFICIENT_DATA</code> is a valid <code>ComplianceType</code> that is returned when an Config rule cannot be evaluated. However, <code>INSUFFICIENT_DATA</code> cannot be used as a <code>ComplianceType</code> for filtering results.</p><br>
    ///   - [`limit(i32)`](crate::operation::get_compliance_details_by_config_rule::builders::GetComplianceDetailsByConfigRuleFluentBuilder::limit) / [`set_limit(Option<i32>)`](crate::operation::get_compliance_details_by_config_rule::builders::GetComplianceDetailsByConfigRuleFluentBuilder::set_limit):<br>required: **false**<br><p>The maximum number of evaluation results returned on each page. The default is 10. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p><br>
    ///   - [`next_token(impl Into<String>)`](crate::operation::get_compliance_details_by_config_rule::builders::GetComplianceDetailsByConfigRuleFluentBuilder::next_token) / [`set_next_token(Option<String>)`](crate::operation::get_compliance_details_by_config_rule::builders::GetComplianceDetailsByConfigRuleFluentBuilder::set_next_token):<br>required: **false**<br><p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p><br>
    /// - On success, responds with [`GetComplianceDetailsByConfigRuleOutput`](crate::operation::get_compliance_details_by_config_rule::GetComplianceDetailsByConfigRuleOutput) with field(s):
    ///   - [`evaluation_results(Option<Vec::<EvaluationResult>>)`](crate::operation::get_compliance_details_by_config_rule::GetComplianceDetailsByConfigRuleOutput::evaluation_results): <p>Indicates whether the Amazon Web Services resource complies with the specified Config rule.</p>
    ///   - [`next_token(Option<String>)`](crate::operation::get_compliance_details_by_config_rule::GetComplianceDetailsByConfigRuleOutput::next_token): <p>The string that you use in a subsequent request to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<GetComplianceDetailsByConfigRuleError>`](crate::operation::get_compliance_details_by_config_rule::GetComplianceDetailsByConfigRuleError)
    pub fn get_compliance_details_by_config_rule(
        &self,
    ) -> crate::operation::get_compliance_details_by_config_rule::builders::GetComplianceDetailsByConfigRuleFluentBuilder {
        crate::operation::get_compliance_details_by_config_rule::builders::GetComplianceDetailsByConfigRuleFluentBuilder::new(self.handle.clone())
    }
}
