// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`ListAggregateDiscoveredResources`](crate::operation::list_aggregate_discovered_resources::builders::ListAggregateDiscoveredResourcesFluentBuilder) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::operation::list_aggregate_discovered_resources::builders::ListAggregateDiscoveredResourcesFluentBuilder::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::operation::list_aggregate_discovered_resources::builders::ListAggregateDiscoveredResourcesFluentBuilder::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::operation::list_aggregate_discovered_resources::builders::ListAggregateDiscoveredResourcesFluentBuilder::set_configuration_aggregator_name):<br>required: **true**<br><p>The name of the configuration aggregator.</p><br>
    ///   - [`resource_type(ResourceType)`](crate::operation::list_aggregate_discovered_resources::builders::ListAggregateDiscoveredResourcesFluentBuilder::resource_type) / [`set_resource_type(Option<ResourceType>)`](crate::operation::list_aggregate_discovered_resources::builders::ListAggregateDiscoveredResourcesFluentBuilder::set_resource_type):<br>required: **true**<br><p>The type of resources that you want Config to list in the response.</p><br>
    ///   - [`filters(ResourceFilters)`](crate::operation::list_aggregate_discovered_resources::builders::ListAggregateDiscoveredResourcesFluentBuilder::filters) / [`set_filters(Option<ResourceFilters>)`](crate::operation::list_aggregate_discovered_resources::builders::ListAggregateDiscoveredResourcesFluentBuilder::set_filters):<br>required: **false**<br><p>Filters the results based on the <code>ResourceFilters</code> object.</p><br>
    ///   - [`limit(i32)`](crate::operation::list_aggregate_discovered_resources::builders::ListAggregateDiscoveredResourcesFluentBuilder::limit) / [`set_limit(Option<i32>)`](crate::operation::list_aggregate_discovered_resources::builders::ListAggregateDiscoveredResourcesFluentBuilder::set_limit):<br>required: **false**<br><p>The maximum number of resource identifiers returned on each page. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p><br>
    ///   - [`next_token(impl Into<String>)`](crate::operation::list_aggregate_discovered_resources::builders::ListAggregateDiscoveredResourcesFluentBuilder::next_token) / [`set_next_token(Option<String>)`](crate::operation::list_aggregate_discovered_resources::builders::ListAggregateDiscoveredResourcesFluentBuilder::set_next_token):<br>required: **false**<br><p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p><br>
    /// - On success, responds with [`ListAggregateDiscoveredResourcesOutput`](crate::operation::list_aggregate_discovered_resources::ListAggregateDiscoveredResourcesOutput) with field(s):
    ///   - [`resource_identifiers(Option<Vec::<AggregateResourceIdentifier>>)`](crate::operation::list_aggregate_discovered_resources::ListAggregateDiscoveredResourcesOutput::resource_identifiers): <p>Returns a list of <code>ResourceIdentifiers</code> objects.</p>
    ///   - [`next_token(Option<String>)`](crate::operation::list_aggregate_discovered_resources::ListAggregateDiscoveredResourcesOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<ListAggregateDiscoveredResourcesError>`](crate::operation::list_aggregate_discovered_resources::ListAggregateDiscoveredResourcesError)
    pub fn list_aggregate_discovered_resources(
        &self,
    ) -> crate::operation::list_aggregate_discovered_resources::builders::ListAggregateDiscoveredResourcesFluentBuilder {
        crate::operation::list_aggregate_discovered_resources::builders::ListAggregateDiscoveredResourcesFluentBuilder::new(self.handle.clone())
    }
}
