// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`ListConformancePackComplianceScores`](crate::operation::list_conformance_pack_compliance_scores::builders::ListConformancePackComplianceScoresFluentBuilder) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::operation::list_conformance_pack_compliance_scores::builders::ListConformancePackComplianceScoresFluentBuilder::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`filters(ConformancePackComplianceScoresFilters)`](crate::operation::list_conformance_pack_compliance_scores::builders::ListConformancePackComplianceScoresFluentBuilder::filters) / [`set_filters(Option<ConformancePackComplianceScoresFilters>)`](crate::operation::list_conformance_pack_compliance_scores::builders::ListConformancePackComplianceScoresFluentBuilder::set_filters):<br>required: **false**<br><p>Filters the results based on the <code>ConformancePackComplianceScoresFilters</code>.</p><br>
    ///   - [`sort_order(SortOrder)`](crate::operation::list_conformance_pack_compliance_scores::builders::ListConformancePackComplianceScoresFluentBuilder::sort_order) / [`set_sort_order(Option<SortOrder>)`](crate::operation::list_conformance_pack_compliance_scores::builders::ListConformancePackComplianceScoresFluentBuilder::set_sort_order):<br>required: **false**<br><p>Determines the order in which conformance pack compliance scores are sorted. Either in ascending or descending order.</p> <p>By default, conformance pack compliance scores are sorted in alphabetical order by name of the conformance pack. Conformance pack compliance scores are sorted in reverse alphabetical order if you enter <code>DESCENDING</code>.</p> <p>You can sort conformance pack compliance scores by the numerical value of the compliance score by entering <code>SCORE</code> in the <code>SortBy</code> action. When compliance scores are sorted by <code>SCORE</code>, conformance packs with a compliance score of <code>INSUFFICIENT_DATA</code> will be last when sorting by ascending order and first when sorting by descending order.</p><br>
    ///   - [`sort_by(SortBy)`](crate::operation::list_conformance_pack_compliance_scores::builders::ListConformancePackComplianceScoresFluentBuilder::sort_by) / [`set_sort_by(Option<SortBy>)`](crate::operation::list_conformance_pack_compliance_scores::builders::ListConformancePackComplianceScoresFluentBuilder::set_sort_by):<br>required: **false**<br><p>Sorts your conformance pack compliance scores in either ascending or descending order, depending on <code>SortOrder</code>.</p> <p>By default, conformance pack compliance scores are sorted in alphabetical order by name of the conformance pack. Enter <code>SCORE</code>, to sort conformance pack compliance scores by the numerical value of the compliance score.</p><br>
    ///   - [`limit(i32)`](crate::operation::list_conformance_pack_compliance_scores::builders::ListConformancePackComplianceScoresFluentBuilder::limit) / [`set_limit(Option<i32>)`](crate::operation::list_conformance_pack_compliance_scores::builders::ListConformancePackComplianceScoresFluentBuilder::set_limit):<br>required: **false**<br><p>The maximum number of conformance pack compliance scores returned on each page.</p><br>
    ///   - [`next_token(impl Into<String>)`](crate::operation::list_conformance_pack_compliance_scores::builders::ListConformancePackComplianceScoresFluentBuilder::next_token) / [`set_next_token(Option<String>)`](crate::operation::list_conformance_pack_compliance_scores::builders::ListConformancePackComplianceScoresFluentBuilder::set_next_token):<br>required: **false**<br><p>The <code>nextToken</code> string in a prior request that you can use to get the paginated response for the next set of conformance pack compliance scores.</p><br>
    /// - On success, responds with [`ListConformancePackComplianceScoresOutput`](crate::operation::list_conformance_pack_compliance_scores::ListConformancePackComplianceScoresOutput) with field(s):
    ///   - [`next_token(Option<String>)`](crate::operation::list_conformance_pack_compliance_scores::ListConformancePackComplianceScoresOutput::next_token): <p>The <code>nextToken</code> string that you can use to get the next page of results in a paginated response.</p>
    ///   - [`conformance_pack_compliance_scores(Vec::<ConformancePackComplianceScore>)`](crate::operation::list_conformance_pack_compliance_scores::ListConformancePackComplianceScoresOutput::conformance_pack_compliance_scores): <p>A list of <code>ConformancePackComplianceScore</code> objects.</p>
    /// - On failure, responds with [`SdkError<ListConformancePackComplianceScoresError>`](crate::operation::list_conformance_pack_compliance_scores::ListConformancePackComplianceScoresError)
    pub fn list_conformance_pack_compliance_scores(
        &self,
    ) -> crate::operation::list_conformance_pack_compliance_scores::builders::ListConformancePackComplianceScoresFluentBuilder {
        crate::operation::list_conformance_pack_compliance_scores::builders::ListConformancePackComplianceScoresFluentBuilder::new(
            self.handle.clone(),
        )
    }
}
