// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`PutEvaluations`](crate::operation::put_evaluations::builders::PutEvaluationsFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`evaluations(Evaluation)`](crate::operation::put_evaluations::builders::PutEvaluationsFluentBuilder::evaluations) / [`set_evaluations(Option<Vec::<Evaluation>>)`](crate::operation::put_evaluations::builders::PutEvaluationsFluentBuilder::set_evaluations):<br>required: **false**<br><p>The assessments that the Lambda function performs. Each evaluation identifies an Amazon Web Services resource and indicates whether it complies with the Config rule that invokes the Lambda function.</p><br>
    ///   - [`result_token(impl Into<String>)`](crate::operation::put_evaluations::builders::PutEvaluationsFluentBuilder::result_token) / [`set_result_token(Option<String>)`](crate::operation::put_evaluations::builders::PutEvaluationsFluentBuilder::set_result_token):<br>required: **true**<br><p>An encrypted token that associates an evaluation with an Config rule. Identifies the rule and the event that triggered the evaluation.</p><br>
    ///   - [`test_mode(bool)`](crate::operation::put_evaluations::builders::PutEvaluationsFluentBuilder::test_mode) / [`set_test_mode(Option<bool>)`](crate::operation::put_evaluations::builders::PutEvaluationsFluentBuilder::set_test_mode):<br>required: **false**<br><p>Use this parameter to specify a test run for <code>PutEvaluations</code>. You can verify whether your Lambda function will deliver evaluation results to Config. No updates occur to your existing evaluations, and evaluation results are not sent to Config.</p><note>  <p>When <code>TestMode</code> is <code>true</code>, <code>PutEvaluations</code> doesn't require a valid value for the <code>ResultToken</code> parameter, but the value cannot be null.</p> </note><br>
    /// - On success, responds with [`PutEvaluationsOutput`](crate::operation::put_evaluations::PutEvaluationsOutput) with field(s):
    ///   - [`failed_evaluations(Option<Vec::<Evaluation>>)`](crate::operation::put_evaluations::PutEvaluationsOutput::failed_evaluations): <p>Requests that failed because of a client or server error.</p>
    /// - On failure, responds with [`SdkError<PutEvaluationsError>`](crate::operation::put_evaluations::PutEvaluationsError)
    pub fn put_evaluations(&self) -> crate::operation::put_evaluations::builders::PutEvaluationsFluentBuilder {
        crate::operation::put_evaluations::builders::PutEvaluationsFluentBuilder::new(self.handle.clone())
    }
}
