// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`PutOrganizationConfigRule`](crate::operation::put_organization_config_rule::builders::PutOrganizationConfigRuleFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`organization_config_rule_name(impl Into<String>)`](crate::operation::put_organization_config_rule::builders::PutOrganizationConfigRuleFluentBuilder::organization_config_rule_name) / [`set_organization_config_rule_name(Option<String>)`](crate::operation::put_organization_config_rule::builders::PutOrganizationConfigRuleFluentBuilder::set_organization_config_rule_name):<br>required: **true**<br><p>The name that you assign to an organization Config rule.</p><br>
    ///   - [`organization_managed_rule_metadata(OrganizationManagedRuleMetadata)`](crate::operation::put_organization_config_rule::builders::PutOrganizationConfigRuleFluentBuilder::organization_managed_rule_metadata) / [`set_organization_managed_rule_metadata(Option<OrganizationManagedRuleMetadata>)`](crate::operation::put_organization_config_rule::builders::PutOrganizationConfigRuleFluentBuilder::set_organization_managed_rule_metadata):<br>required: **false**<br><p>An <code>OrganizationManagedRuleMetadata</code> object. This object specifies organization managed rule metadata such as resource type and ID of Amazon Web Services resource along with the rule identifier. It also provides the frequency with which you want Config to run evaluations for the rule if the trigger type is periodic.</p><br>
    ///   - [`organization_custom_rule_metadata(OrganizationCustomRuleMetadata)`](crate::operation::put_organization_config_rule::builders::PutOrganizationConfigRuleFluentBuilder::organization_custom_rule_metadata) / [`set_organization_custom_rule_metadata(Option<OrganizationCustomRuleMetadata>)`](crate::operation::put_organization_config_rule::builders::PutOrganizationConfigRuleFluentBuilder::set_organization_custom_rule_metadata):<br>required: **false**<br><p>An <code>OrganizationCustomRuleMetadata</code> object. This object specifies organization custom rule metadata such as resource type, resource ID of Amazon Web Services resource, Lambda function ARN, and organization trigger types that trigger Config to evaluate your Amazon Web Services resources against a rule. It also provides the frequency with which you want Config to run evaluations for the rule if the trigger type is periodic.</p><br>
    ///   - [`excluded_accounts(impl Into<String>)`](crate::operation::put_organization_config_rule::builders::PutOrganizationConfigRuleFluentBuilder::excluded_accounts) / [`set_excluded_accounts(Option<Vec::<String>>)`](crate::operation::put_organization_config_rule::builders::PutOrganizationConfigRuleFluentBuilder::set_excluded_accounts):<br>required: **false**<br><p>A comma-separated list of accounts that you want to exclude from an organization Config rule.</p><br>
    ///   - [`organization_custom_policy_rule_metadata(OrganizationCustomPolicyRuleMetadata)`](crate::operation::put_organization_config_rule::builders::PutOrganizationConfigRuleFluentBuilder::organization_custom_policy_rule_metadata) / [`set_organization_custom_policy_rule_metadata(Option<OrganizationCustomPolicyRuleMetadata>)`](crate::operation::put_organization_config_rule::builders::PutOrganizationConfigRuleFluentBuilder::set_organization_custom_policy_rule_metadata):<br>required: **false**<br><p>An <code>OrganizationCustomPolicyRuleMetadata</code> object. This object specifies metadata for your organization's Config Custom Policy rule. The metadata includes the runtime system in use, which accounts have debug logging enabled, and other custom rule metadata, such as resource type, resource ID of Amazon Web Services resource, and organization trigger types that initiate Config to evaluate Amazon Web Services resources against a rule.</p><br>
    /// - On success, responds with [`PutOrganizationConfigRuleOutput`](crate::operation::put_organization_config_rule::PutOrganizationConfigRuleOutput) with field(s):
    ///   - [`organization_config_rule_arn(Option<String>)`](crate::operation::put_organization_config_rule::PutOrganizationConfigRuleOutput::organization_config_rule_arn): <p>The Amazon Resource Name (ARN) of an organization Config rule.</p>
    /// - On failure, responds with [`SdkError<PutOrganizationConfigRuleError>`](crate::operation::put_organization_config_rule::PutOrganizationConfigRuleError)
    pub fn put_organization_config_rule(&self) -> crate::operation::put_organization_config_rule::builders::PutOrganizationConfigRuleFluentBuilder {
        crate::operation::put_organization_config_rule::builders::PutOrganizationConfigRuleFluentBuilder::new(self.handle.clone())
    }
}
