// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`PutResourceConfig`](crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`resource_type(impl Into<String>)`](crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder::resource_type) / [`set_resource_type(Option<String>)`](crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder::set_resource_type):<br>required: **true**<br><p>The type of the resource. The custom resource type must be registered with CloudFormation.</p><note>  <p>You cannot use the organization names “amzn”, “amazon”, “alexa”, “custom” with custom resource types. It is the first part of the ResourceType up to the first ::.</p> </note><br>
    ///   - [`schema_version_id(impl Into<String>)`](crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder::schema_version_id) / [`set_schema_version_id(Option<String>)`](crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder::set_schema_version_id):<br>required: **true**<br><p>Version of the schema registered for the ResourceType in CloudFormation.</p><br>
    ///   - [`resource_id(impl Into<String>)`](crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder::resource_id) / [`set_resource_id(Option<String>)`](crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder::set_resource_id):<br>required: **true**<br><p>Unique identifier of the resource.</p><br>
    ///   - [`resource_name(impl Into<String>)`](crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder::resource_name) / [`set_resource_name(Option<String>)`](crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder::set_resource_name):<br>required: **false**<br><p>Name of the resource.</p><br>
    ///   - [`configuration(impl Into<String>)`](crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder::configuration) / [`set_configuration(Option<String>)`](crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder::set_configuration):<br>required: **true**<br><p>The configuration object of the resource in valid JSON format. It must match the schema registered with CloudFormation.</p><note>  <p>The configuration JSON must not exceed 64 KB.</p> </note><br>
    ///   - [`tags(impl Into<String>, impl Into<String>)`](crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder::tags) / [`set_tags(Option<HashMap::<String, String>>)`](crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder::set_tags):<br>required: **false**<br><p>Tags associated with the resource.</p><note>  <p>This field is not to be confused with the Amazon Web Services-wide tag feature for Amazon Web Services resources. Tags for <code>PutResourceConfig</code> are tags that you supply for the configuration items of your custom resources.</p> </note><br>
    /// - On success, responds with [`PutResourceConfigOutput`](crate::operation::put_resource_config::PutResourceConfigOutput)
    /// - On failure, responds with [`SdkError<PutResourceConfigError>`](crate::operation::put_resource_config::PutResourceConfigError)
    pub fn put_resource_config(&self) -> crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder {
        crate::operation::put_resource_config::builders::PutResourceConfigFluentBuilder::new(self.handle.clone())
    }
}
