// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`StartResourceEvaluation`](crate::operation::start_resource_evaluation::builders::StartResourceEvaluationFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`resource_details(ResourceDetails)`](crate::operation::start_resource_evaluation::builders::StartResourceEvaluationFluentBuilder::resource_details) / [`set_resource_details(Option<ResourceDetails>)`](crate::operation::start_resource_evaluation::builders::StartResourceEvaluationFluentBuilder::set_resource_details):<br>required: **true**<br><p>Returns a <code>ResourceDetails</code> object.</p><br>
    ///   - [`evaluation_context(EvaluationContext)`](crate::operation::start_resource_evaluation::builders::StartResourceEvaluationFluentBuilder::evaluation_context) / [`set_evaluation_context(Option<EvaluationContext>)`](crate::operation::start_resource_evaluation::builders::StartResourceEvaluationFluentBuilder::set_evaluation_context):<br>required: **false**<br><p>Returns an <code>EvaluationContext</code> object.</p><br>
    ///   - [`evaluation_mode(EvaluationMode)`](crate::operation::start_resource_evaluation::builders::StartResourceEvaluationFluentBuilder::evaluation_mode) / [`set_evaluation_mode(Option<EvaluationMode>)`](crate::operation::start_resource_evaluation::builders::StartResourceEvaluationFluentBuilder::set_evaluation_mode):<br>required: **true**<br><p>The mode of an evaluation. The valid values for this API are <code>DETECTIVE</code> and <code>PROACTIVE</code>.</p><br>
    ///   - [`evaluation_timeout(i32)`](crate::operation::start_resource_evaluation::builders::StartResourceEvaluationFluentBuilder::evaluation_timeout) / [`set_evaluation_timeout(Option<i32>)`](crate::operation::start_resource_evaluation::builders::StartResourceEvaluationFluentBuilder::set_evaluation_timeout):<br>required: **false**<br><p>The timeout for an evaluation. The default is 900 seconds. You cannot specify a number greater than 3600. If you specify 0, Config uses the default.</p><br>
    ///   - [`client_token(impl Into<String>)`](crate::operation::start_resource_evaluation::builders::StartResourceEvaluationFluentBuilder::client_token) / [`set_client_token(Option<String>)`](crate::operation::start_resource_evaluation::builders::StartResourceEvaluationFluentBuilder::set_client_token):<br>required: **false**<br><p>A client token is a unique, case-sensitive string of up to 64 ASCII characters. To make an idempotent API request using one of these actions, specify a client token in the request.</p><note>  <p>Avoid reusing the same client token for other API requests. If you retry a request that completed successfully using the same client token and the same parameters, the retry succeeds without performing any further actions. If you retry a successful request using the same client token, but one or more of the parameters are different, other than the Region or Availability Zone, the retry fails with an IdempotentParameterMismatch error.</p> </note><br>
    /// - On success, responds with [`StartResourceEvaluationOutput`](crate::operation::start_resource_evaluation::StartResourceEvaluationOutput) with field(s):
    ///   - [`resource_evaluation_id(Option<String>)`](crate::operation::start_resource_evaluation::StartResourceEvaluationOutput::resource_evaluation_id): <p>A unique ResourceEvaluationId that is associated with a single execution.</p>
    /// - On failure, responds with [`SdkError<StartResourceEvaluationError>`](crate::operation::start_resource_evaluation::StartResourceEvaluationError)
    pub fn start_resource_evaluation(&self) -> crate::operation::start_resource_evaluation::builders::StartResourceEvaluationFluentBuilder {
        crate::operation::start_resource_evaluation::builders::StartResourceEvaluationFluentBuilder::new(self.handle.clone())
    }
}
