// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
pub use crate::operation::delete_delivery_channel::_delete_delivery_channel_output::DeleteDeliveryChannelOutputBuilder;

pub use crate::operation::delete_delivery_channel::_delete_delivery_channel_input::DeleteDeliveryChannelInputBuilder;

impl DeleteDeliveryChannelInputBuilder {
    /// Sends a request with this input using the given client.
    pub async fn send_with(
        self,
        client: &crate::Client,
    ) -> ::std::result::Result<
        crate::operation::delete_delivery_channel::DeleteDeliveryChannelOutput,
        ::aws_smithy_runtime_api::client::result::SdkError<
            crate::operation::delete_delivery_channel::DeleteDeliveryChannelError,
            ::aws_smithy_runtime_api::client::orchestrator::HttpResponse,
        >,
    > {
        let mut fluent_builder = client.delete_delivery_channel();
        fluent_builder.inner = self;
        fluent_builder.send().await
    }
}
/// Fluent builder constructing a request to `DeleteDeliveryChannel`.
///
/// <p>Deletes the delivery channel.</p>
/// <p>Before you can delete the delivery channel, you must stop the configuration recorder by using the <code>StopConfigurationRecorder</code> action.</p>
#[derive(::std::clone::Clone, ::std::fmt::Debug)]
pub struct DeleteDeliveryChannelFluentBuilder {
    handle: ::std::sync::Arc<crate::client::Handle>,
    inner: crate::operation::delete_delivery_channel::builders::DeleteDeliveryChannelInputBuilder,
    config_override: ::std::option::Option<crate::config::Builder>,
}
impl
    crate::client::customize::internal::CustomizableSend<
        crate::operation::delete_delivery_channel::DeleteDeliveryChannelOutput,
        crate::operation::delete_delivery_channel::DeleteDeliveryChannelError,
    > for DeleteDeliveryChannelFluentBuilder
{
    fn send(
        self,
        config_override: crate::config::Builder,
    ) -> crate::client::customize::internal::BoxFuture<
        crate::client::customize::internal::SendResult<
            crate::operation::delete_delivery_channel::DeleteDeliveryChannelOutput,
            crate::operation::delete_delivery_channel::DeleteDeliveryChannelError,
        >,
    > {
        ::std::boxed::Box::pin(async move { self.config_override(config_override).send().await })
    }
}
impl DeleteDeliveryChannelFluentBuilder {
    /// Creates a new `DeleteDeliveryChannel`.
    pub(crate) fn new(handle: ::std::sync::Arc<crate::client::Handle>) -> Self {
        Self {
            handle,
            inner: ::std::default::Default::default(),
            config_override: ::std::option::Option::None,
        }
    }
    /// Access the DeleteDeliveryChannel as a reference.
    pub fn as_input(&self) -> &crate::operation::delete_delivery_channel::builders::DeleteDeliveryChannelInputBuilder {
        &self.inner
    }
    /// Sends the request and returns the response.
    ///
    /// If an error occurs, an `SdkError` will be returned with additional details that
    /// can be matched against.
    ///
    /// By default, any retryable failures will be retried twice. Retry behavior
    /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
    /// set when configuring the client.
    pub async fn send(
        self,
    ) -> ::std::result::Result<
        crate::operation::delete_delivery_channel::DeleteDeliveryChannelOutput,
        ::aws_smithy_runtime_api::client::result::SdkError<
            crate::operation::delete_delivery_channel::DeleteDeliveryChannelError,
            ::aws_smithy_runtime_api::client::orchestrator::HttpResponse,
        >,
    > {
        let input = self
            .inner
            .build()
            .map_err(::aws_smithy_runtime_api::client::result::SdkError::construction_failure)?;
        let runtime_plugins = crate::operation::delete_delivery_channel::DeleteDeliveryChannel::operation_runtime_plugins(
            self.handle.runtime_plugins.clone(),
            &self.handle.conf,
            self.config_override,
        );
        crate::operation::delete_delivery_channel::DeleteDeliveryChannel::orchestrate(&runtime_plugins, input).await
    }

    /// Consumes this builder, creating a customizable operation that can be modified before being sent.
    pub fn customize(
        self,
    ) -> crate::client::customize::CustomizableOperation<
        crate::operation::delete_delivery_channel::DeleteDeliveryChannelOutput,
        crate::operation::delete_delivery_channel::DeleteDeliveryChannelError,
        Self,
    > {
        crate::client::customize::CustomizableOperation::new(self)
    }
    pub(crate) fn config_override(mut self, config_override: impl Into<crate::config::Builder>) -> Self {
        self.set_config_override(Some(config_override.into()));
        self
    }

    pub(crate) fn set_config_override(&mut self, config_override: Option<crate::config::Builder>) -> &mut Self {
        self.config_override = config_override;
        self
    }
    /// <p>The name of the delivery channel to delete.</p>
    pub fn delivery_channel_name(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.inner = self.inner.delivery_channel_name(input.into());
        self
    }
    /// <p>The name of the delivery channel to delete.</p>
    pub fn set_delivery_channel_name(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.inner = self.inner.set_delivery_channel_name(input);
        self
    }
    /// <p>The name of the delivery channel to delete.</p>
    pub fn get_delivery_channel_name(&self) -> &::std::option::Option<::std::string::String> {
        self.inner.get_delivery_channel_name()
    }
}
