// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::fmt::Debug)]
pub struct DescribeConformancePackComplianceOutput {
    /// <p>Name of the conformance pack.</p>
    pub conformance_pack_name: ::std::string::String,
    /// <p>Returns a list of <code>ConformancePackRuleCompliance</code> objects.</p>
    pub conformance_pack_rule_compliance_list: ::std::vec::Vec<crate::types::ConformancePackRuleCompliance>,
    /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    pub next_token: ::std::option::Option<::std::string::String>,
    _request_id: Option<String>,
}
impl DescribeConformancePackComplianceOutput {
    /// <p>Name of the conformance pack.</p>
    pub fn conformance_pack_name(&self) -> &str {
        use std::ops::Deref;
        self.conformance_pack_name.deref()
    }
    /// <p>Returns a list of <code>ConformancePackRuleCompliance</code> objects.</p>
    pub fn conformance_pack_rule_compliance_list(&self) -> &[crate::types::ConformancePackRuleCompliance] {
        use std::ops::Deref;
        self.conformance_pack_rule_compliance_list.deref()
    }
    /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    pub fn next_token(&self) -> ::std::option::Option<&str> {
        self.next_token.as_deref()
    }
}
impl ::aws_types::request_id::RequestId for DescribeConformancePackComplianceOutput {
    fn request_id(&self) -> Option<&str> {
        self._request_id.as_deref()
    }
}
impl DescribeConformancePackComplianceOutput {
    /// Creates a new builder-style object to manufacture [`DescribeConformancePackComplianceOutput`](crate::operation::describe_conformance_pack_compliance::DescribeConformancePackComplianceOutput).
    pub fn builder() -> crate::operation::describe_conformance_pack_compliance::builders::DescribeConformancePackComplianceOutputBuilder {
        crate::operation::describe_conformance_pack_compliance::builders::DescribeConformancePackComplianceOutputBuilder::default()
    }
}

/// A builder for [`DescribeConformancePackComplianceOutput`](crate::operation::describe_conformance_pack_compliance::DescribeConformancePackComplianceOutput).
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default, ::std::fmt::Debug)]
pub struct DescribeConformancePackComplianceOutputBuilder {
    pub(crate) conformance_pack_name: ::std::option::Option<::std::string::String>,
    pub(crate) conformance_pack_rule_compliance_list: ::std::option::Option<::std::vec::Vec<crate::types::ConformancePackRuleCompliance>>,
    pub(crate) next_token: ::std::option::Option<::std::string::String>,
    _request_id: Option<String>,
}
impl DescribeConformancePackComplianceOutputBuilder {
    /// <p>Name of the conformance pack.</p>
    /// This field is required.
    pub fn conformance_pack_name(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.conformance_pack_name = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>Name of the conformance pack.</p>
    pub fn set_conformance_pack_name(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.conformance_pack_name = input;
        self
    }
    /// <p>Name of the conformance pack.</p>
    pub fn get_conformance_pack_name(&self) -> &::std::option::Option<::std::string::String> {
        &self.conformance_pack_name
    }
    /// Appends an item to `conformance_pack_rule_compliance_list`.
    ///
    /// To override the contents of this collection use [`set_conformance_pack_rule_compliance_list`](Self::set_conformance_pack_rule_compliance_list).
    ///
    /// <p>Returns a list of <code>ConformancePackRuleCompliance</code> objects.</p>
    pub fn conformance_pack_rule_compliance_list(mut self, input: crate::types::ConformancePackRuleCompliance) -> Self {
        let mut v = self.conformance_pack_rule_compliance_list.unwrap_or_default();
        v.push(input);
        self.conformance_pack_rule_compliance_list = ::std::option::Option::Some(v);
        self
    }
    /// <p>Returns a list of <code>ConformancePackRuleCompliance</code> objects.</p>
    pub fn set_conformance_pack_rule_compliance_list(
        mut self,
        input: ::std::option::Option<::std::vec::Vec<crate::types::ConformancePackRuleCompliance>>,
    ) -> Self {
        self.conformance_pack_rule_compliance_list = input;
        self
    }
    /// <p>Returns a list of <code>ConformancePackRuleCompliance</code> objects.</p>
    pub fn get_conformance_pack_rule_compliance_list(&self) -> &::std::option::Option<::std::vec::Vec<crate::types::ConformancePackRuleCompliance>> {
        &self.conformance_pack_rule_compliance_list
    }
    /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    pub fn next_token(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.next_token = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    pub fn set_next_token(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.next_token = input;
        self
    }
    /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    pub fn get_next_token(&self) -> &::std::option::Option<::std::string::String> {
        &self.next_token
    }
    pub(crate) fn _request_id(mut self, request_id: impl Into<String>) -> Self {
        self._request_id = Some(request_id.into());
        self
    }

    pub(crate) fn _set_request_id(&mut self, request_id: Option<String>) -> &mut Self {
        self._request_id = request_id;
        self
    }
    /// Consumes the builder and constructs a [`DescribeConformancePackComplianceOutput`](crate::operation::describe_conformance_pack_compliance::DescribeConformancePackComplianceOutput).
    /// This method will fail if any of the following fields are not set:
    /// - [`conformance_pack_name`](crate::operation::describe_conformance_pack_compliance::builders::DescribeConformancePackComplianceOutputBuilder::conformance_pack_name)
    /// - [`conformance_pack_rule_compliance_list`](crate::operation::describe_conformance_pack_compliance::builders::DescribeConformancePackComplianceOutputBuilder::conformance_pack_rule_compliance_list)
    pub fn build(
        self,
    ) -> ::std::result::Result<
        crate::operation::describe_conformance_pack_compliance::DescribeConformancePackComplianceOutput,
        ::aws_smithy_types::error::operation::BuildError,
    > {
        ::std::result::Result::Ok(
            crate::operation::describe_conformance_pack_compliance::DescribeConformancePackComplianceOutput {
                conformance_pack_name: self.conformance_pack_name
                    .ok_or_else(||
                        ::aws_smithy_types::error::operation::BuildError::missing_field("conformance_pack_name", "conformance_pack_name was not specified but it is required when building DescribeConformancePackComplianceOutput")
                    )?
                ,
                conformance_pack_rule_compliance_list: self.conformance_pack_rule_compliance_list
                    .ok_or_else(||
                        ::aws_smithy_types::error::operation::BuildError::missing_field("conformance_pack_rule_compliance_list", "conformance_pack_rule_compliance_list was not specified but it is required when building DescribeConformancePackComplianceOutput")
                    )?
                ,
                next_token: self.next_token
                ,
                _request_id: self._request_id,
            }
        )
    }
}
