// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::fmt::Debug)]
pub struct SelectAggregateResourceConfigOutput {
    /// <p>Returns the results for the SQL query.</p>
    pub results: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    /// <p>Details about the query.</p>
    pub query_info: ::std::option::Option<crate::types::QueryInfo>,
    /// <p>The nextToken string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    pub next_token: ::std::option::Option<::std::string::String>,
    _request_id: Option<String>,
}
impl SelectAggregateResourceConfigOutput {
    /// <p>Returns the results for the SQL query.</p>
    ///
    /// If no value was sent for this field, a default will be set. If you want to determine if no value was sent, use `.results.is_none()`.
    pub fn results(&self) -> &[::std::string::String] {
        self.results.as_deref().unwrap_or_default()
    }
    /// <p>Details about the query.</p>
    pub fn query_info(&self) -> ::std::option::Option<&crate::types::QueryInfo> {
        self.query_info.as_ref()
    }
    /// <p>The nextToken string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    pub fn next_token(&self) -> ::std::option::Option<&str> {
        self.next_token.as_deref()
    }
}
impl ::aws_types::request_id::RequestId for SelectAggregateResourceConfigOutput {
    fn request_id(&self) -> Option<&str> {
        self._request_id.as_deref()
    }
}
impl SelectAggregateResourceConfigOutput {
    /// Creates a new builder-style object to manufacture [`SelectAggregateResourceConfigOutput`](crate::operation::select_aggregate_resource_config::SelectAggregateResourceConfigOutput).
    pub fn builder() -> crate::operation::select_aggregate_resource_config::builders::SelectAggregateResourceConfigOutputBuilder {
        crate::operation::select_aggregate_resource_config::builders::SelectAggregateResourceConfigOutputBuilder::default()
    }
}

/// A builder for [`SelectAggregateResourceConfigOutput`](crate::operation::select_aggregate_resource_config::SelectAggregateResourceConfigOutput).
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default, ::std::fmt::Debug)]
pub struct SelectAggregateResourceConfigOutputBuilder {
    pub(crate) results: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    pub(crate) query_info: ::std::option::Option<crate::types::QueryInfo>,
    pub(crate) next_token: ::std::option::Option<::std::string::String>,
    _request_id: Option<String>,
}
impl SelectAggregateResourceConfigOutputBuilder {
    /// Appends an item to `results`.
    ///
    /// To override the contents of this collection use [`set_results`](Self::set_results).
    ///
    /// <p>Returns the results for the SQL query.</p>
    pub fn results(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        let mut v = self.results.unwrap_or_default();
        v.push(input.into());
        self.results = ::std::option::Option::Some(v);
        self
    }
    /// <p>Returns the results for the SQL query.</p>
    pub fn set_results(mut self, input: ::std::option::Option<::std::vec::Vec<::std::string::String>>) -> Self {
        self.results = input;
        self
    }
    /// <p>Returns the results for the SQL query.</p>
    pub fn get_results(&self) -> &::std::option::Option<::std::vec::Vec<::std::string::String>> {
        &self.results
    }
    /// <p>Details about the query.</p>
    pub fn query_info(mut self, input: crate::types::QueryInfo) -> Self {
        self.query_info = ::std::option::Option::Some(input);
        self
    }
    /// <p>Details about the query.</p>
    pub fn set_query_info(mut self, input: ::std::option::Option<crate::types::QueryInfo>) -> Self {
        self.query_info = input;
        self
    }
    /// <p>Details about the query.</p>
    pub fn get_query_info(&self) -> &::std::option::Option<crate::types::QueryInfo> {
        &self.query_info
    }
    /// <p>The nextToken string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    pub fn next_token(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.next_token = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>The nextToken string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    pub fn set_next_token(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.next_token = input;
        self
    }
    /// <p>The nextToken string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    pub fn get_next_token(&self) -> &::std::option::Option<::std::string::String> {
        &self.next_token
    }
    pub(crate) fn _request_id(mut self, request_id: impl Into<String>) -> Self {
        self._request_id = Some(request_id.into());
        self
    }

    pub(crate) fn _set_request_id(&mut self, request_id: Option<String>) -> &mut Self {
        self._request_id = request_id;
        self
    }
    /// Consumes the builder and constructs a [`SelectAggregateResourceConfigOutput`](crate::operation::select_aggregate_resource_config::SelectAggregateResourceConfigOutput).
    pub fn build(self) -> crate::operation::select_aggregate_resource_config::SelectAggregateResourceConfigOutput {
        crate::operation::select_aggregate_resource_config::SelectAggregateResourceConfigOutput {
            results: self.results,
            query_info: self.query_info,
            next_token: self.next_token,
            _request_id: self._request_id,
        }
    }
}
