// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.

/// <p>Provides a summary of compliance based on either account ID or region.</p>
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::fmt::Debug)]
pub struct AggregateConformancePackComplianceSummary {
    /// <p>Returns an <code>AggregateConformancePackComplianceCount</code> object.</p>
    pub compliance_summary: ::std::option::Option<crate::types::AggregateConformancePackComplianceCount>,
    /// <p>Groups the result based on Amazon Web Services account ID or Amazon Web Services Region.</p>
    pub group_name: ::std::option::Option<::std::string::String>,
}
impl AggregateConformancePackComplianceSummary {
    /// <p>Returns an <code>AggregateConformancePackComplianceCount</code> object.</p>
    pub fn compliance_summary(&self) -> ::std::option::Option<&crate::types::AggregateConformancePackComplianceCount> {
        self.compliance_summary.as_ref()
    }
    /// <p>Groups the result based on Amazon Web Services account ID or Amazon Web Services Region.</p>
    pub fn group_name(&self) -> ::std::option::Option<&str> {
        self.group_name.as_deref()
    }
}
impl AggregateConformancePackComplianceSummary {
    /// Creates a new builder-style object to manufacture [`AggregateConformancePackComplianceSummary`](crate::types::AggregateConformancePackComplianceSummary).
    pub fn builder() -> crate::types::builders::AggregateConformancePackComplianceSummaryBuilder {
        crate::types::builders::AggregateConformancePackComplianceSummaryBuilder::default()
    }
}

/// A builder for [`AggregateConformancePackComplianceSummary`](crate::types::AggregateConformancePackComplianceSummary).
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default, ::std::fmt::Debug)]
pub struct AggregateConformancePackComplianceSummaryBuilder {
    pub(crate) compliance_summary: ::std::option::Option<crate::types::AggregateConformancePackComplianceCount>,
    pub(crate) group_name: ::std::option::Option<::std::string::String>,
}
impl AggregateConformancePackComplianceSummaryBuilder {
    /// <p>Returns an <code>AggregateConformancePackComplianceCount</code> object.</p>
    pub fn compliance_summary(mut self, input: crate::types::AggregateConformancePackComplianceCount) -> Self {
        self.compliance_summary = ::std::option::Option::Some(input);
        self
    }
    /// <p>Returns an <code>AggregateConformancePackComplianceCount</code> object.</p>
    pub fn set_compliance_summary(mut self, input: ::std::option::Option<crate::types::AggregateConformancePackComplianceCount>) -> Self {
        self.compliance_summary = input;
        self
    }
    /// <p>Returns an <code>AggregateConformancePackComplianceCount</code> object.</p>
    pub fn get_compliance_summary(&self) -> &::std::option::Option<crate::types::AggregateConformancePackComplianceCount> {
        &self.compliance_summary
    }
    /// <p>Groups the result based on Amazon Web Services account ID or Amazon Web Services Region.</p>
    pub fn group_name(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.group_name = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>Groups the result based on Amazon Web Services account ID or Amazon Web Services Region.</p>
    pub fn set_group_name(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.group_name = input;
        self
    }
    /// <p>Groups the result based on Amazon Web Services account ID or Amazon Web Services Region.</p>
    pub fn get_group_name(&self) -> &::std::option::Option<::std::string::String> {
        &self.group_name
    }
    /// Consumes the builder and constructs a [`AggregateConformancePackComplianceSummary`](crate::types::AggregateConformancePackComplianceSummary).
    pub fn build(self) -> crate::types::AggregateConformancePackComplianceSummary {
        crate::types::AggregateConformancePackComplianceSummary {
            compliance_summary: self.compliance_summary,
            group_name: self.group_name,
        }
    }
}
